import time

from netforce.model import Model, fields, get_model
from netforce.access import get_active_company

class Doctor(Model):
    _name="clinic.doctor"
    _string="Doctor"
    _audit_log=True
    _multi_company=True
    _fields={
        "number": fields.Char("Doctor No.",required=True,search=True),
        "name": fields.Char("Name",required=True,search=True),
        "card_id" : fields.Char("Identity ID"),
        "card_expire" : fields.Date("Expire Date"),
        "birthday": fields.Date("Date of Birth",search=True),
        "telephone": fields.Char("Telephone",search=True),
        "type": fields.Selection([("temporary","Temporary"),("permanent","Permanent")],"Type"),
        "mobile": fields.Char("Mobile",required=False,search=True),
        "cert_no" : fields.Char("Certificate No."),
        "cert_date" : fields.Date("Certificate Date"),
        "birthday": fields.Date("BirthDay",search=True),
        "telephone": fields.Char("Telephone",search=True),
        "department_id": fields.Many2One("clinic.department", "Department",search=True),
        "mobile": fields.Char("Mobile",search=True),
        "state": fields.Selection([("draft","Draft"),("active","Active"),("deactive","Deactive")],"Status"),
        "addresses": fields.One2Many("address","related_id","Addresses"),
        "comments": fields.One2Many("message","related_id","Comments"),
        "patients": fields.Many2Many("clinic.patient","Patients"),
        "visits": fields.One2Many("clinic.visit","nurse_id","Visits"),
        "hd_cases": fields.One2Many("clinic.hd.case","nurse_id","HD cases"),
        "company_id": fields.Many2One("company","Company"),
    }

    def _get_number(self,context={}):
        while 1:
            num=get_model("sequence").get_number("sale_order")
            if not num:
                return None
            res=self.search([["number","=",num]])
            if not res:
                return num
            get_model("sequence").increment("sale_order")


    _defaults={
        "type": "temporary",
        "date": lambda *a: time.strftime("%Y-%m-%d"),
        "number": _get_number,
        "company_id": lambda *a: get_active_company(),
    }
    _order="date desc,number desc"


    def void(self,ids,context={}):
        obj=self.browse(ids)[0]
        obj.write({"state":"voided"})


Doctor.register()
